/**
 * @file EC_Proxy_Disconnector.cpp
 *
 * $Id: EC_Proxy_Disconnector.cpp 71526 2006-03-14 06:14:35Z jtc $
 *
 * @author Carlos O'Ryan <coryan@atdesk.com>
 */

#include "orbsvcs/Event/EC_Proxy_Disconnector.h"

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

void
TAO_EC_Supplier_Proxy_Disconnect_Functor::operator() (
                       RtecEventComm::PushSupplier_ptr supplier)
  ACE_THROW_SPEC (())
{
  ACE_DECLARE_NEW_CORBA_ENV;
  ACE_TRY
    {
      supplier->disconnect_push_supplier (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;
    }
  ACE_CATCHALL
    {
    }
  ACE_ENDTRY;
}

void
TAO_EC_Consumer_Proxy_Disconnect_Functor::operator() (
                       RtecEventComm::PushConsumer_ptr consumer)
  ACE_THROW_SPEC (())
{
  ACE_DECLARE_NEW_CORBA_ENV;
  ACE_TRY
    {
      consumer->disconnect_push_consumer (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;
    }
  ACE_CATCHALL
    {
    }
  ACE_ENDTRY;
}

TAO_END_VERSIONED_NAMESPACE_DECL
