#include "tao/Service_Callbacks.h"
#include "tao/ORB_Constants.h"
#include "tao/SystemException.h"
#include "tao/Environment.h"
#include "tao/Invocation_Utils.h"

ACE_RCSID (tao,
           Service_Callbacks,
           "$Id: Service_Callbacks.cpp 72136 2006-04-19 09:10:19Z jwillemsen $")


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

TAO_Service_Callbacks::~TAO_Service_Callbacks (void)
{
}

CORBA::Boolean
TAO_Service_Callbacks::select_profile (TAO_MProfile * /*mprofile*/,
                                       TAO_Profile *& /*pfile*/)
{
  return false;
}

CORBA::Boolean
TAO_Service_Callbacks::reselect_profile (TAO_Stub * /*stub*/,
                                         TAO_Profile *& /*pfile*/)
{
  return false;
}


CORBA::Boolean
TAO_Service_Callbacks::object_is_nil (CORBA::Object_ptr /* obj */)
{
  // We shouldn't be here at all. But in case if we are here,
  // something is wrong. So, we send a true for a is_nil () call
  return true;
}

void
TAO_Service_Callbacks::reset_profile_flags (void)
{
  return;
}


TAO_Service_Callbacks::Profile_Equivalence
TAO_Service_Callbacks::is_profile_equivalent (const TAO_Profile *,
                                              const TAO_Profile *)
{
  return DONT_KNOW;
}

CORBA::ULong
TAO_Service_Callbacks::hash_ft (TAO_Profile *,
                                CORBA::ULong )
{
  return 0;
}

CORBA::Boolean
TAO_Service_Callbacks::is_permanent_forward_condition (const CORBA::Object_ptr,
                                                       const TAO_Service_Context &) const
{
  return false;
}

TAO::Invocation_Status
TAO_Service_Callbacks::raise_comm_failure (
    IOP::ServiceContextList &,
    TAO_Profile * /*profile*/
    ACE_ENV_ARG_DECL)
{
  ACE_THROW_RETURN (CORBA::COMM_FAILURE (
      CORBA::SystemException::_tao_minor_code (
          TAO_INVOCATION_RECV_REQUEST_MINOR_CODE,
          -1),
      CORBA::COMPLETED_MAYBE),
      TAO::TAO_INVOKE_FAILURE);
}

TAO::Invocation_Status
TAO_Service_Callbacks::raise_transient_failure (
    IOP::ServiceContextList &,
    TAO_Profile * /*profile*/
    ACE_ENV_ARG_DECL)
{
  ACE_THROW_RETURN (CORBA::TRANSIENT (
      CORBA::SystemException::_tao_minor_code (
          TAO_INVOCATION_RECV_REQUEST_MINOR_CODE,
          -1),
      CORBA::COMPLETED_MAYBE),
      TAO::TAO_INVOKE_FAILURE);
}

TAO_END_VERSIONED_NAMESPACE_DECL
